import {
    world
} from "@minecraft/server"
import {
    Mana
} from "./main.js"

export function spells() {
    for (const player of world.getPlayers()) {
        const item = player.getComponent("equippable").getEquipment("Mainhand")


        //Healing Spells
        if (item?.typeId == "magicraft:heal_spell") {
            if (Mana <= 30) {
                player.addEffect("regeneration", 200, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:heal_spells", 300);

            }
        }


        //Resistance Spells
        if (item?.typeId == "magicraft:resistance_spell") {
            if (Mana <= 30) {
                player.addEffect("resistance", 1200, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:resistance_spells", 1800);

            }
        }


        //Fire Resistance Spells
        if (item?.typeId == "magicraft:fire_protection") {
            if (Mana <= 30) {
                player.addEffect("fire_resistance", 1200, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:resistance_spells", 1800);
            }
        }


        //Fang Evocation Spells
        if (item?.typeId == "magicraft:fang_summoning") {
            //Level 0-5
            if (Mana <= 30) {

                if (player.isSneaking == true) {
                    if (player?.getEntitiesFromViewDirection().length != 0) {
                        const getEntity = player.getEntitiesFromViewDirection().pop().entity

                        //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                        getEntity.runCommand("summon evocation_fang ~ ~ ~")
                        getEntity.runCommand("damage @s 7 magic entity @p")

                    }
                    else if (player?.getEntitiesFromViewDirection().length == 0) {
                        return;
                    }
                }
                else if (player.isSneaking == false) {
                    player.runCommand("execute at @e[family=monster,r=15] run summon evocation_fang ~ ~ ~")
                    player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")
                }
            }
        }


        //Induce Wither Spells
        if (item?.typeId == "magicraft:induce_wither") {
            //Level 0-5
            if (Mana <= 30) {
                //player.runCommand("effect @e[family=monster,r=15] wither 10 0 true")
                player.startItemCooldown("magicraft:attack_spells", 300);

                if (player.isSneaking == true) {
                    if (player?.getEntitiesFromViewDirection().length != 0) {
                        const getEntity = player.getEntitiesFromViewDirection().pop().entity

                        //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                        getEntity.addEffect("wither", 200, { showParticles: true, amplifier: 1 })
                        getEntity.runCommand("damage @s 0 magic entity @p")

                    }
                    else if (player?.getEntitiesFromViewDirection().length == 0) {
                        return;
                    }
                }
                else if (player.isSneaking == false) {
                    player.runCommand("effect @e[family=monster,r=15] wither 10 0 false")
                    player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")
                }
            }
        }


        //Night Sight Spells
        if (item?.typeId == "magicraft:night_vision_spell") {
            if (Mana <= 30) {
                player.addEffect("night_vision", 1200, { showParticles: false })
                player.removeEffect("blindness")
                player.startItemCooldown("magicraft:support_spells", 1800);

            }
        }


        //Reanimation Spells
        if (item?.typeId == "magicraft:reanimation_spell") {
            //Level 0-5
            if (Mana <= 30) {
                player.runCommand("function reanimate")
                player.startItemCooldown("magicraft:attack_spells", 1200);

            }
        }


        //Summon Thunder Spells
        if (item?.typeId == "magicraft:thunder_spell") {
            //Level 0-5
            if (Mana <= 30) {
                //player.runCommand("execute at @e[family=monster,r=15] run summon lightning_bolt ~ ~ ~")
                //player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")


                if (player.isSneaking == true) {
                    if (player?.getEntitiesFromViewDirection().length != 0) {
                        const getEntity = player.getEntitiesFromViewDirection().pop().entity

                        //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                        getEntity.dimension.spawnEntity("lightning_bolt", getEntity.location)
                        getEntity.runCommand("damage @s 4 magic entity @p")
                    }
                    else if (player?.getEntitiesFromViewDirection().length == 0) {
                        return;
                    }
                }
                else if (player.isSneaking == false) {
                    player.runCommand("execute at @e[family=monster,r=15] run summon lightning_bolt ~ ~ ~")
                    player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")
                }
            }
        }


        //Summon Familiar spells
        if (item?.typeId == "magicraft:summon_familiar") {
            //Level 0-5
            if (Mana <= 30) {
                player.startItemCooldown("magicraft:support_spells", 4800);
                player.runCommand("summon magicraft:familiar ~ ~ ~ facing @p")

            }
        }

        //Jumping Spells
        if (item?.typeId == "magicraft:spell_jump") {
            if (Mana <= 30) {
                player.addEffect("jump_boost", 400, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:support_spells", 600);

            }
        }

        //Induce Weakness Spells
        if (item?.typeId == "magicraft:induce_weakness") {
            //Level 0-5
            if (Mana <= 30) {
                //player.runCommand("effect @e[family=monster,r=15] weakness 10 0 false")
                player.startItemCooldown("magicraft:attack_spells", 300);

                if (player.isSneaking == true) {
                    if (player?.getEntitiesFromViewDirection().length != 0) {
                        const getEntity = player.getEntitiesFromViewDirection().pop().entity

                        //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                        getEntity.addEffect("weakness", 200, { showParticles: true, amplifier: 2 })
                        getEntity.runCommand("damage @s 0 magic entity @p")

                    }
                    else if (player?.getEntitiesFromViewDirection().length == 0) {
                        return;
                    }
                }
                else if (player.isSneaking == false) {
                    player.runCommand("effect @e[family=monster,r=15] weakness 10 0 false")
                    player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")
                }
            }
        }

        //Water Affinity Spells
        if (item?.typeId == "magicraft:spell_waffinity") {
            if (Mana <= 30) {
                player.addEffect("water_breathing", 1200, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:support_spells", 1800);

            }
        }

        //Clairvoyance Spells
        if (item?.typeId == "magicraft:spell_clairvoyance") {
            if (Mana <= 30) {
                player.addEffect("conduit_power", 1200, { showParticles: false, amplifier: 1 })
                player.removeEffect("blindness")
                player.startItemCooldown("magicraft:support_spells", 1800);
            }
        }

        //Protection Spells
        if (item?.typeId == "magicraft:spell_protection") {
            if (Mana <= 30) {
                player.addEffect("resistance", 1200, { showParticles: false, amplifier: 1 })
                player.addEffect("fire_resistance", 1200, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:resistance_spells", 1800);

            }
        }

        //Absorption Spells
        if (item?.typeId == "magicraft:spell_absorption") {
            if (Mana <= 30) {
                player.addEffect("absorption", 400, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:heal_spells", 600);

            }
        }

        //Wound Mending Spells
        if (item?.typeId == "magicraft:spell_wmending") {
            if (Mana <= 30) {
                player.addEffect("absorption", 200, { showParticles: false, amplifier: 1 })
                player.addEffect("regeneration", 400, { showParticles: false, amplifier: 1 })
                player.startItemCooldown("magicraft:heal_spells", 600);

            }
        }

        //Decay Spells
        if (item?.typeId == "magicraft:spell_decay") {
            //Level 0-5
            if (Mana <= 30) {
                //player.runCommand("effect @e[family=monster,r=15] weakness 10 0 false")
                //player.runCommand("effect @e[family=monster,r=15] wither 10 0 false")
                player.startItemCooldown("magicraft:attack_spells", 300);

                if (player.isSneaking == true) {
                    if (player?.getEntitiesFromViewDirection().length != 0) {
                        const getEntity = player.getEntitiesFromViewDirection().pop().entity

                        //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                        getEntity.addEffect("weakness", 200, { showParticles: true, amplifier: 2 })
                        getEntity.addEffect("wither", 200, { showParticles: true, amplifier: 1 })
                        getEntity.runCommand("damage @s 0 magic entity @p")

                    }
                    else if (player?.getEntitiesFromViewDirection().length == 0) {
                        return;
                    }
                }
                else if (player.isSneaking == false) {
                    player.runCommand("effect @e[family=monster,r=15] weakness 10 0 false")
                    player.runCommand("effect @e[family=monster,r=15] wither 10 0 false")
                    player.runCommand("damage @e[family=monster,r=15] 0 magic entity @p")
                }
            }
        }
    }
}


export function staves() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Mainhand")


        if (item?.typeId == "magicraft:staff_healing") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("regeneration", 400, { showParticles: false, amplifier: 0 })
            player.startItemCooldown("magicraft:staves", 800);

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:staff_resistance") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("resistance", 1200, { showParticles: false, amplifier: 0 })
            player.startItemCooldown("magicraft:staves", 1800);

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:staff_nv") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("night_vision", 1200, { showParticles: false, amplifier: 0 })
            player.startItemCooldown("magicraft:staves", 1800);

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:staff_invis") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("invisibility", 1200, { showParticles: false, amplifier: 0 })
            player.startItemCooldown("magicraft:staves", 1800);

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
    }
}

export function attackStaves() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Mainhand")

        if (item?.typeId == "magicraft:staff_fang") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            if (player.isSneaking == true) {
                if (player?.getEntitiesFromViewDirection().length != 0) {
                    const getEntity = player.getEntitiesFromViewDirection().pop().entity

                    //player.runCommand("summon evocation_fang " + getEntity.location.x + " " + getEntity.location.y + " " + getEntity.location.z);
                    getEntity.runCommand("summon evocation_fang ~ ~ ~")
                    getEntity.runCommand("damage @s 0 magic entity @p")

                }
                else if (player?.getEntitiesFromViewDirection().length == 0) {
                    return;
                }
            }
            else {
                player.runCommand("execute at @e[family=monster,r=15,c=2] run summon evocation_fang ~ ~ ~")
                player.runCommand("damage @e[family=monster,r=15,c=2] 0 magic entity @p")

            }

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }


        else if (item?.typeId == "magicraft:staff_thunder") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            if (player.isSneaking == true) {
                if (player?.getEntitiesFromViewDirection().length != 0) {
                    const getEntity = player.getEntitiesFromViewDirection().pop().entity

                    player.dimension.spawnEntity("lightning_bolt", getEntity.location)
                    getEntity.runCommand("damage @s 0 magic entity @p")
                }
                else if (player?.getEntitiesFromViewDirection().length == 0) {
                    return;
                }
            }
            else {
                player.runCommand("execute at @e[family=monster,r=15,c=2] run summon lightning_bolt ~ ~ ~")
                player.runCommand("damage @e[family=monster,r=15,c=2] 0 magic entity @p")
            }

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
    }
}

export function scrolls() {
    for (const player of world.getPlayers()) {
        const item = player?.getComponent("equippable").getEquipment("Mainhand")

        if (item?.typeId == "magicraft:scroll_healing") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("instant_health", 1, { showParticles: false, amplifier: 0 })

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:scroll_resistance") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("resistance", 1200, { showParticles: false, amplifier: 0 })

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:scroll_nv") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("night_vision", 1200, { showParticles: false, amplifier: 0 })

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:scroll_fang") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.runCommand("execute at @e[family=monster,r=15,c=1] run summon evocation_fang ~ ~ ~")
            player.runCommand("damage @e[family=monster,r=15,c=1] 0 magic entity @p")

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:scroll_thunder") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.runCommand("execute at @e[family=monster,r=15,c=1] run summon lightning_bolt ~ ~ ~")
            player.runCommand("damage @e[family=monster,r=15,c=1] 0 magic entity @p")

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
        else if (item?.typeId == "magicraft:scroll_invis") {
            const damage = item.getComponent("durability").damage;
            const durability = item.getComponent("durability").maxDurability;
            const inv = player.getComponent("inventory").container

            player.addEffect("invisibility", 200, { showParticles: false, amplifier: 0 })

            if (damage == durability) {
                inv.setItem(player.selectedSlotIndex, null)
            }
            else {
                item.getComponent("durability").damage += 1;
                inv.setItem(player.selectedSlotIndex, item);
            }
        }
    }
}